$regfile = "m16def.dat"
$crystal = 8000000
$hwstack = 64
$swstack = 64
$framesize = 150
$baud = 9600

'Define I/O and name them
Config Porta.0 = Output                                     '    GND
Porta.0 = 0
Config Porta.5 = Output                                     'D/C (pin 4)
D3310dc Alias Porta.5
Config Porta.6 = Output                                     'SCE (pin 5)
D3310ce Alias Porta.6
Config Porta.7 = Output                                     'Reset (pin 8)
D3310re Alias Porta.7
Config Porta.2 = Output
Porta.2 = 1
' SPI   . SCLK (pin 2) - PORTD.0; SDA (pin 3) - PORTD.1;
Config Spi = Soft , Din = Portb.1 , Dout = Porta.4 , Ss = None , Clock = Porta.3
Spiinit
$include "3310init.bas"

' SPI
Call D3310reset
Call D3310init
Call D3310clear



'=====[ Global Vars & Constants ]===============================================
Dim Hmc_x As Integer
Dim Hmc_xl As Byte At Hmc_x + 0 Overlay
Dim Hmc_xh As Byte At Hmc_x + 1 Overlay

Dim Hmc_y As Integer
Dim Hmc_yl As Byte At Hmc_y + 0 Overlay
Dim Hmc_yh As Byte At Hmc_y + 1 Overlay

Dim Hmc_z As Integer
Dim Hmc_zl As Byte At Hmc_z + 0 Overlay
Dim Hmc_zh As Byte At Hmc_z + 1 Overlay
Dim Hmc_status As Byte

Dim X As Single
Dim Y As Single
Dim Z As Single
Dim Angle As Single
Dim Angle_str As String * 6


Const Hmc_w = &H3C                                          ' HMC5883L Write address
Const Hmc_r = &H3D                                          ' HMC5883L Read  address

'-------------------------------------------------------------------------------

Config Scl = Portc.0                                        ' needed if using soft I2C
Config Sda = Portc.1                                        ' needed if using soft I2C
Config Twi = 400000                                         ' set the I2C bus to 'fast' speed
I2cinit

Print "{027}[2J{027}[1;1H";                                 ' ansi clear screen
Print "Starting..."
Print

Gosub Hmc_initialize



Do

   Gosub Hmc_readdata
   Gosub Hmc_readstatus

  ' convert integer to float
   X = Hmc_x
   Y = Hmc_y
   Z = Hmc_z

   ' Calculate angle:
   ' angle= atan2((double)y,(double)x) * (180 / 3.14159265) + 180
   Angle = Atn2(y , X)
   Angle = Angle * 57.29577951                              ' (180 / 3.14159265)
   Angle = Angle + 180

'Angle = Angle + 1                                           '  
'If Angle > 360 Then
'Angle = 0
'End If

   Angle_str = Fusing(angle , "#.#")
   Angle_str = Angle_str + ""

   Print "Angle  : " ; Angle_str
   Print "Status : " ; "&h" ; Hex(hmc_status) ; "{027}[K"



   If Angle => 0 And Angle < 11.25 Then
    Restore D3310bmp1
    Call D3310bmpout

   End If

   If Angle => 11.25 And Angle < 33.75 Then
    Restore D3310bmp16
    Call D3310bmpout
   End If

   If Angle => 33.75 And Angle < 56.25 Then
    Restore D3310bmp15
    Call D3310bmpout
   End If

   If Angle => 56.25 And Angle < 78.75 Then
    Restore D3310bmp14
    Call D3310bmpout
   End If

   If Angle => 78.75 And Angle < 101.25 Then
    Restore D3310bmp13
    Call D3310bmpout
   End If

   If Angle => 101.25 And Angle < 123.75 Then
    Restore D3310bmp12
    Call D3310bmpout
   End If


   If Angle => 123.75 And Angle < 146.25 Then
    Restore D3310bmp11
    Call D3310bmpout
   End If


   If Angle => 146.25 And Angle < 168.75 Then
    Restore D3310bmp10
    Call D3310bmpout
   End If


   If Angle => 168.75 And Angle < 191.25 Then
    Restore D3310bmp9
    Call D3310bmpout
   End If


   If Angle => 191.25 And Angle < 213.75 Then
    Restore D3310bmp8
    Call D3310bmpout
   End If


   If Angle => 213.75 And Angle < 236.25 Then
    Restore D3310bmp7
    Call D3310bmpout
   End If


   If Angle => 236.25 And Angle < 258.75 Then
    Restore D3310bmp6
    Call D3310bmpout
   End If

   If Angle => 258.75 And Angle < 281.25 Then
    Restore D3310bmp5
    Call D3310bmpout
   End If


   If Angle => 281.25 And Angle < 303.75 Then
    Restore D3310bmp4
    Call D3310bmpout
   End If


   If Angle => 303.75 And Angle < 326.25 Then
    Restore D3310bmp3
    Call D3310bmpout
   End If


   If Angle => 326.25 And Angle < 348.75 Then
    Restore D3310bmp2
    Call D3310bmpout
   End If

   If Angle => 348.75 Then
    Restore D3310bmp1
    Call D3310bmpout
   End If



    Call D3310position(0 , 5)
    Call D3310print(angle_str )


   Waitms 100



Loop


End

$include "3310end.bas"
$include "3310bmp1.bas"
$include "3310bmp2.bas"
$include "3310bmp3.bas"
$include "3310bmp4.bas"
$include "3310bmp5.bas"
$include "3310bmp6.bas"
$include "3310bmp7.bas"
$include "3310bmp8.bas"
$include "3310bmp9.bas"
$include "3310bmp10.bas"
$include "3310bmp11.bas"
$include "3310bmp12.bas"
$include "3310bmp13.bas"
$include "3310bmp14.bas"
$include "3310bmp15.bas"
$include "3310bmp16.bas"



'=====[ Initialize HMC Compass ]================================================
Hmc_initialize:
' Initialize free running mode for compass
   I2cstart
    I2cwbyte Hmc_w
    I2cwbyte &H00                                           ' set register possition to 0
    I2cwbyte &B0101_1000                                    ' set ConfRegA [4samples, 75Hz, normal]
    I2cwbyte &H0010_0000                                    ' set ConfRegC [gain to default (1090)]
    I2cwbyte &H0000_0000                                    ' set free running mode
   I2cstop
Return
'-------------------------------------------------------------------------------

'=====[ Read HMC Compass ]======================================================
Hmc_readstatus:
' Read HMC Compass status
   I2cstart
    I2cwbyte Hmc_w
    I2cwbyte &H09                                           ' set read position
   I2cstart
    I2cwbyte Hmc_r
    I2crbyte Hmc_status , Nack                              ' read in status
   I2cstop
Return
'-------------------------------------------------------------------------------

'=====[ Read HMC Compass ]======================================================
Hmc_readdata:
' Read HMC Compass X, Y, Z integer values
   I2cstart
    I2cwbyte Hmc_w
    I2cwbyte &H03                                           ' set read position
   I2cstart
    I2cwbyte Hmc_r
    I2crbyte Hmc_xh , Ack                                   ' read in high order x
    I2crbyte Hmc_xl , Ack                                   ' read in low  order x
    I2crbyte Hmc_zh , Ack                                   ' read in high order z
    I2crbyte Hmc_zl , Ack                                   ' read in low  order z
    I2crbyte Hmc_yh , Ack                                   ' read in high order y
    I2crbyte Hmc_yl , Nack                                  ' read in low  order y
   I2cstop
Return
'-------------------------------------------------------------------------------